# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from akeyless.configuration import Configuration


class CreatePasskey(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'accessibility': 'str',
        'alg': 'str',
        'delete_protection': 'str',
        'description': 'str',
        'json': 'bool',
        'name': 'str',
        'origin_url': 'list[str]',
        'protection_key_name': 'str',
        'tags': 'list[str]',
        'token': 'str',
        'uid_token': 'str',
        'username': 'str'
    }

    attribute_map = {
        'accessibility': 'accessibility',
        'alg': 'alg',
        'delete_protection': 'delete_protection',
        'description': 'description',
        'json': 'json',
        'name': 'name',
        'origin_url': 'origin-url',
        'protection_key_name': 'protection-key-name',
        'tags': 'tags',
        'token': 'token',
        'uid_token': 'uid-token',
        'username': 'username'
    }

    def __init__(self, accessibility='regular', alg='EC256', delete_protection=None, description=None, json=False, name=None, origin_url=None, protection_key_name=None, tags=None, token=None, uid_token=None, username=None, local_vars_configuration=None):  # noqa: E501
        """CreatePasskey - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._accessibility = None
        self._alg = None
        self._delete_protection = None
        self._description = None
        self._json = None
        self._name = None
        self._origin_url = None
        self._protection_key_name = None
        self._tags = None
        self._token = None
        self._uid_token = None
        self._username = None
        self.discriminator = None

        if accessibility is not None:
            self.accessibility = accessibility
        self.alg = alg
        if delete_protection is not None:
            self.delete_protection = delete_protection
        if description is not None:
            self.description = description
        if json is not None:
            self.json = json
        self.name = name
        if origin_url is not None:
            self.origin_url = origin_url
        if protection_key_name is not None:
            self.protection_key_name = protection_key_name
        if tags is not None:
            self.tags = tags
        if token is not None:
            self.token = token
        if uid_token is not None:
            self.uid_token = uid_token
        if username is not None:
            self.username = username

    @property
    def accessibility(self):
        """Gets the accessibility of this CreatePasskey.  # noqa: E501

        for personal password manager  # noqa: E501

        :return: The accessibility of this CreatePasskey.  # noqa: E501
        :rtype: str
        """
        return self._accessibility

    @accessibility.setter
    def accessibility(self, accessibility):
        """Sets the accessibility of this CreatePasskey.

        for personal password manager  # noqa: E501

        :param accessibility: The accessibility of this CreatePasskey.  # noqa: E501
        :type: str
        """

        self._accessibility = accessibility

    @property
    def alg(self):
        """Gets the alg of this CreatePasskey.  # noqa: E501

        Passkey type; options: [EC256, EC384, EC512]  # noqa: E501

        :return: The alg of this CreatePasskey.  # noqa: E501
        :rtype: str
        """
        return self._alg

    @alg.setter
    def alg(self, alg):
        """Sets the alg of this CreatePasskey.

        Passkey type; options: [EC256, EC384, EC512]  # noqa: E501

        :param alg: The alg of this CreatePasskey.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and alg is None:  # noqa: E501
            raise ValueError("Invalid value for `alg`, must not be `None`")  # noqa: E501

        self._alg = alg

    @property
    def delete_protection(self):
        """Gets the delete_protection of this CreatePasskey.  # noqa: E501

        Protection from accidental deletion of this object [true/false]  # noqa: E501

        :return: The delete_protection of this CreatePasskey.  # noqa: E501
        :rtype: str
        """
        return self._delete_protection

    @delete_protection.setter
    def delete_protection(self, delete_protection):
        """Sets the delete_protection of this CreatePasskey.

        Protection from accidental deletion of this object [true/false]  # noqa: E501

        :param delete_protection: The delete_protection of this CreatePasskey.  # noqa: E501
        :type: str
        """

        self._delete_protection = delete_protection

    @property
    def description(self):
        """Gets the description of this CreatePasskey.  # noqa: E501

        Description of the object  # noqa: E501

        :return: The description of this CreatePasskey.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CreatePasskey.

        Description of the object  # noqa: E501

        :param description: The description of this CreatePasskey.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def json(self):
        """Gets the json of this CreatePasskey.  # noqa: E501

        Set output format to JSON  # noqa: E501

        :return: The json of this CreatePasskey.  # noqa: E501
        :rtype: bool
        """
        return self._json

    @json.setter
    def json(self, json):
        """Sets the json of this CreatePasskey.

        Set output format to JSON  # noqa: E501

        :param json: The json of this CreatePasskey.  # noqa: E501
        :type: bool
        """

        self._json = json

    @property
    def name(self):
        """Gets the name of this CreatePasskey.  # noqa: E501

        ClassicKey name  # noqa: E501

        :return: The name of this CreatePasskey.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreatePasskey.

        ClassicKey name  # noqa: E501

        :param name: The name of this CreatePasskey.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def origin_url(self):
        """Gets the origin_url of this CreatePasskey.  # noqa: E501

        Originating websites for this passkey  # noqa: E501

        :return: The origin_url of this CreatePasskey.  # noqa: E501
        :rtype: list[str]
        """
        return self._origin_url

    @origin_url.setter
    def origin_url(self, origin_url):
        """Sets the origin_url of this CreatePasskey.

        Originating websites for this passkey  # noqa: E501

        :param origin_url: The origin_url of this CreatePasskey.  # noqa: E501
        :type: list[str]
        """

        self._origin_url = origin_url

    @property
    def protection_key_name(self):
        """Gets the protection_key_name of this CreatePasskey.  # noqa: E501

        The name of a key that used to encrypt the secret value (if empty, the account default protectionKey key will be used)  # noqa: E501

        :return: The protection_key_name of this CreatePasskey.  # noqa: E501
        :rtype: str
        """
        return self._protection_key_name

    @protection_key_name.setter
    def protection_key_name(self, protection_key_name):
        """Sets the protection_key_name of this CreatePasskey.

        The name of a key that used to encrypt the secret value (if empty, the account default protectionKey key will be used)  # noqa: E501

        :param protection_key_name: The protection_key_name of this CreatePasskey.  # noqa: E501
        :type: str
        """

        self._protection_key_name = protection_key_name

    @property
    def tags(self):
        """Gets the tags of this CreatePasskey.  # noqa: E501

        Add tags attached to this object  # noqa: E501

        :return: The tags of this CreatePasskey.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this CreatePasskey.

        Add tags attached to this object  # noqa: E501

        :param tags: The tags of this CreatePasskey.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def token(self):
        """Gets the token of this CreatePasskey.  # noqa: E501

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :return: The token of this CreatePasskey.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this CreatePasskey.

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :param token: The token of this CreatePasskey.  # noqa: E501
        :type: str
        """

        self._token = token

    @property
    def uid_token(self):
        """Gets the uid_token of this CreatePasskey.  # noqa: E501

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :return: The uid_token of this CreatePasskey.  # noqa: E501
        :rtype: str
        """
        return self._uid_token

    @uid_token.setter
    def uid_token(self, uid_token):
        """Sets the uid_token of this CreatePasskey.

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :param uid_token: The uid_token of this CreatePasskey.  # noqa: E501
        :type: str
        """

        self._uid_token = uid_token

    @property
    def username(self):
        """Gets the username of this CreatePasskey.  # noqa: E501

        For Password Management use  # noqa: E501

        :return: The username of this CreatePasskey.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this CreatePasskey.

        For Password Management use  # noqa: E501

        :param username: The username of this CreatePasskey.  # noqa: E501
        :type: str
        """

        self._username = username

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreatePasskey):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreatePasskey):
            return True

        return self.to_dict() != other.to_dict()
